###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

__author__ = '$Author: morten $'
__version__ = '$Revision: 1.7 $'

import os
import tempfile
import posix
import string

class fetchmail_box:

    def __init__(self,fp):

        self.fp = fp

    def next(self):

        return rfc822.Message(self.fp)


def build_box(server,username,password,options,protocol='auto'):
	"""An interface to fetchmail."""

	try:
		
		fetchmail_conf = open(tempfile.mktemp(),'w')

		fetchmail_directory = tempfile.mktemp()
		os.mkdir(fetchmail_directory)

		posix.chmod(fetchmail_conf.name,0700)
		posix.chmod(fetchmail_directory,0700)

		fetchmail_conf.write("""set properties ""\n""")
		fetchmail_conf.write("""poll  %s with proto %s\n""" % \
							 (server,protocol))
		fetchmail_conf.write(
			"""user %s there with password %s is '' here\n""" % \
			(username,password))

		if options:

			fetchmail_conf.write("\noptions %s" % (string.join(options,' ')))
                    
		fetchmail_conf.close()

		f = open(tempfile.mktemp(),'w')

		f.write(os.popen(
			'fetchmail -f %s -as -m "mda %s"' % \
			(fetchmail_conf.name, fetchmail_directory),
			'r').read())

		f.close()

		f = open(f.name,'r')

		mbox = fetchmail_box(f)

	except: # Empty except clauses are lame. ?FIXME?

		pass

	# We're not always sure the file exists.

	try:

		os.remove(fetchmail_conf.name)

	except: # Again, empty except clauses are lame.  ?FIXME?

		pass

        return mbox

if __name__ == '__main__':

    mbox = build_box('10.230.8.114','test123','test',['fetchall'])
